character*20 scale_line1,scale_line2

character*8 ar,md,line
character*4 dsaa/'DSAA'/
allocatable dv_map(:,:),dv2_map(:,:),v_abs(:,:)
common/pi/pi,per
common/kod_model/kod_abs, kod_anomaly
common/kod_combi/kod_1,kod_2
common/refmod/nref,href(600),vref(600)

common/relief/nrlf,xrlf(10000),yrlf(10000),sea_lev,v_air,v_sea,v_min


common/syn_start/ k_1start_2syn

one=1.e0
pi=asin(one)*2.e0
per=pi/180.e0

open(1,file='../../model.dat')
read(1,'(a8)')ar
read(1,'(a8)')md
close(1)

i=system('mkdir -p ../../DATA/'//ar//'/'//md//'/data')


open(1,file='../a_define_model/SET.DAT')
read(1,*)k_1start_2syn
read(1,*)n_micro
close(1)

write(*,*)' ar=',ar,' md=',md


key_preview=0
open(1,file='../../preview_key.txt')
read(1,*,end=771)key_preview
771 close(1)

if(key_preview.ne.0) then
	i=system('mkdir -p ../../PICS/ps/'//ar//'/'//md)
	i=system('mkdir -p ../../PICS/png/'//ar//'/'//md)

end if

call read_ISO_ABS(ar,md)
call read_ISO_ANOM(ar,md)

sea_lev=0
nrlf=0
open(1,file='../../DATA/'//ar//'/inidata/relief.bln',status='old',err=992)
read(1,*,end=92)nrlf,sea_lev,v_air,v_sea,v_min
do irlf=1,nrlf
	read(1,*)xrlf(irlf),yrlf(irlf)
end do
92 close(1)
992 continue

!xxx=451.933675
!yyy=103.869897

!vabs = velocity(xxx,yyy)
!write(*,*)' vabs=',vabs

!pause


!******************************************************************

open(1,file='../../DATA/'//ar//'/set_vis.dat')
read(1,*) xmap1,xmap2,dxmap  
read(1,*) ymap1,ymap2,dymap  
close(1)
write(*,*)' xmap1=',xmap1,' xmap2=',xmap2
write(*,*)' ymap1=',ymap1,' ymap2=',ymap2

dxmap=dxmap/n_micro
dymap=dymap/n_micro

nxmap=int_best((xmap2-xmap1)/dxmap)
nymap=int_best((ymap2-ymap1)/dymap)

allocate(dv_map(nxmap,nymap),dv2_map(nxmap,nymap),v_abs(nxmap,nymap))

write(*,*)' nxmap=',nxmap,' nymap=',nymap

vmax=0
vmin=999999999
open(11,file='../../DATA/'//ar//'/'//md//'/data/vav_syn.bln')
write(11,*)nymap

do iy=1,nymap
	yyy=ymap1+(iy-1)*dymap
	vav=0
	do ix=1,nxmap
		xxx=xmap1+(ix-1)*dxmap


		ysurf = relieff(xxx)
		if(yyy.gt.ysurf) then
			v_abs(ix,iy)=-999
			dv_map(ix,iy)=-999
			vav=vav+v_sea
		else
			v_abs(ix,iy)=velocity(xxx,yyy)

			call SYN_ISO_ANOM(xxx,yyy,dv)
			dv_map(ix,iy)=dv
			!write(*,*)' v_abs=',v_abs(ix,iy)
			vav=vav+v_abs(ix,iy)
		end if

		!v0=vrefmod(yyy)

		if(kod_anomaly.eq.3)then

			if(kod_2.eq.1)then
				call dv_BRD_iso_2(xxx,yyy,dv2)
			else if(kod_2.eq.2)then
				call dv_FREE_iso_2(xxx,yyy,dv2)
			end if

			dv2_map(ix,iy)=dv2

		end if


		if(v_abs(ix,iy).gt.vmax)vmax=v_abs(ix,iy)
		if(v_abs(ix,iy).lt.vmin)vmin=v_abs(ix,iy)
	end do
	vav=vav/nxmap
	write(11,*)vav,yyy
	if(mod(iy,100).eq.0)write(*,*)' yyy=',yyy,' vav=',vav
	!stop
end do
close(11)

open(14,file='../../DATA/'//ar//'/'//md//'/data/dv_ini.grd')
write(14,'(a4)')dsaa
write(14,*)nxmap,nymap
write(14,*)xmap1,xmap2
write(14,*)ymap1,ymap2
write(14,*)-999,999
do iy=1,nymap
	write(14,*)(dv_map(ix,iy),ix=1,nxmap)
end do
close(14)

open(14,file='../../FIG_files/syn_mod/dv_ini.grd')
write(14,'(a4)')dsaa
write(14,*)nxmap,nymap
write(14,*)xmap1,xmap2
write(14,*)ymap1,ymap2
write(14,*)-999,999
do iy=1,nymap
	write(14,*)(dv_map(ix,iy),ix=1,nxmap)
end do
close(14)

if(kod_anomaly.eq.3)then

open(14,file='../../FIG_files/syn_mod/dv2_ini.grd')
	write(14,'(a4)')dsaa
	write(14,*)nxmap,nymap
	write(14,*)xmap1,xmap2
	write(14,*)ymap1,ymap2
	write(14,*)-999,999
	do iy=1,nymap
		write(14,*)(dv2_map(ix,iy),ix=1,nxmap)
	end do
	close(14)
end if



open(14,file='../../FIG_files/syn_mod/abs_ini.grd')
write(14,'(a4)')dsaa
write(14,*)nxmap,nymap
write(14,*)xmap1,xmap2
write(14,*)ymap1,ymap2
write(14,*)vmin,vmax
do iy=1,nymap
	write(14,*)(v_abs(ix,iy),ix=1,nxmap)
end do
close(14)

if(key_preview.eq.0) stop

!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************



stop
end
