character*8 ar,md,line

common/ray_param/ds_ini,ds_segm_min,bend_min0,bend_max0
common/refmod/nref,href(600),vref(600)
common/nanom/n_anomaly
common/ray_xyv/nodes,xray(10000),yray(10000),vray(10000),sray(10000)
common/surface/nsurf,xsurf(100),ysurf(100)
common/param_reg_bend/step,segm_min,bendreg_min,bendreg_max
common/pi/pi,per

common/relief/nrlf,xrlf(10000),yrlf(10000),sea_lev,v_air,v_sea,v_min

common/param_sea_bend/bendsurf_max,bendsurf_min,dy_deeper
common/syn_start/ k_syn_start


one=1.e0
pi=asin(one)*2.e0
per=pi/180.e0

k_syn_start=2
!ifreq=4


bendsurf_max=3
bendsurf_min=0.05

open(1, file='../../model.dat')
read(1,'(a8)')ar
read(1,'(a8)')md
close(1)

call read_ISO_ABS(ar,md)
call read_ISO_ANOM(ar,md)


nrlf=0
sea_lev=0
v_air=0.01
v_sea=1.0
v_min=1
open(1,file='../../DATA/'//ar//'/inidata/relief.bln',status='old',err=992)
read(1,*,end=92)nrlf,sea_lev,v_air,v_sea,v_min
do irlf=1,nrlf
	read(1,*)xrlf(irlf),yrlf(irlf)
end do
92 close(1)
992 continue

!x=100
!do y=0.,-8,-0.5
!	v= velocity(x,y)
!	write(*,*)' y=',y,' v=',v
!end do
!pause


!******************************************************************
open(1,file='../../DATA/'//ar//'/'//md//'/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=553)line
	if(line.eq.'REG.BEND') goto 554
end do
553 continue
write(*,*)' cannot find REG.BENDING PARAMETERS in MAJOR_PARAM.DAT!!!'
pause
554 continue
read(1,*)step
read(1,*)segm_min
read(1,*)bendreg_min
read(1,*)bendreg_max
read(1,*)ifreq_screen
read(1,*)ifreq_ray
read(1,*)res_max
read(1,*)
read(1,*)disbot_min
close(1)

step=step/3


!do xx=-10.,200.,5.
!	x=xx
!	h=sea_bottom(x)
!	write(*,*)' x=',x,' h=',h
!end do
!pause

!goto 1313

!write(*,*)ds_ini,ds_part_min,val_bend_min,bend_max0

open(1,file='../../DATA/'//ar//'/inidata/rays0.dat')

open(11,file='../../DATA/'//ar//'/'//md//'/data/rays 0.dat',form='binary')
open(41,file='../../FIG_files/rays/rays_syn.bln')
open(42,file='../../FIG_files/rays/godog_syn.dat')
open(43,file='../../FIG_files/rays/godog_zt_syn.dat')
open(44,file='../../FIG_files/rays/godog_st_syn.dat')

disp0=0
disp1=0
nbad=0
nray=0
nray0=0

1	continue
	read(1,*,end=2) xzt,yzt,xst,yst,tobs


!xzt=10
!xst=90
!yst=sea_bottom(xst)

!write(*,*)' xst=',xst,' yst=',yst

	
	nray0=nray0+1
	!if(mod(nray0,ifreq).ne.0) goto 1


	!write(*,*)' xst=',xst,' yst=',yst
	!write(*,*)' xzt=',xzt,' yzt=',yzt

	if(abs(xzt-xst).lt.disbot_min) then
		nbad=nbad+1
		goto 1
	end if


	call trace_1_arrival_sea(xzt,yzt,xst,yst,	xzt_bot,yzt_bot,tmod)

!	write(*,*)' tmod=',tmod,' nodes=',nodes



	if(abs(xzt_bot-xst).lt.disbot_min) then
		nbad=nbad+1
		goto 1
	end if


	nray=nray+1

	
!if(nray.eq.100) stop


	dt1=tobs-tmod
	disp1=disp1+abs(dt1)


	write(42,*)abs(xzt-xst),tmod
	write(43,*)xzt,tmod
	write(44,*)xst,tmod


	write(11)xzt,yzt,xst,yst,tmod,tmod

	if(mod(nray,ifreq_ray).eq.0) then
		write(41,*)nodes+1
		write(41,*)xzt,yzt
		do i=1,nodes
			write(41,*)xray(i),yray(i)
		end do
	end if

	if(mod(nray,ifreq_screen).eq.0) then
		disp_cur=disp1/nray
		write(*,34)nray,abs(xzt-xst),yst,dt1,disp_cur
34 format(i5,' dist=',f8.1,' yst=',f8.1,'   dt=',f10.3,' disp=',f10.3)
	end if
	goto 1
2 close(1)
close(11)
close(12)
close(42)
close(41)

write(*,*)' nbad=',nbad,' nray=',nray


1313 continue

key_preview=0
open(1,file='../../preview_key.txt')
read(1,*,end=771)key_preview
771 close(1)

if(key_preview.eq.0) stop

!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************





stop
end
