subroutine read_ISO_ANOM(ar,md)
character*8 ar,md
common/kod_model/kod_abs, kod_anomaly
common/syn_start/ k_syn_start


kod_anomaly=0
if(k_syn_start.eq.1) then
	open(1,file='../../DATA/'//ar//'/'//md//'/anomaly_start.dat',status='old',err=31)
	write(*,*)' STARTING VELOCITY MODEL'
else if(k_syn_start.eq.2) then
	open(1,file='../../DATA/'//ar//'/'//md//'/anomaly_syn.dat',status='old',err=31)
	write(*,*)' SYNTHETIC VELOCITY MODEL'
else
	write(*,*)' k_syn_start is not defined:',k_syn_start
	pause
end if

read(1,*,end=1) kod_anomaly  
1 close(1)
write(*,*)' kod_anomaly=',kod_anomaly
if(kod_anomaly.eq.0) return

if(kod_anomaly.eq.1)then
	write(*,*)' ISOTROPIC BRD:'
	write(*,*)
	call read_BRD_iso(ar,md)
else if(kod_anomaly.eq.2)then
	write(*,*)' ISOTROPIC FREE ANOMALY:'
	write(*,*)
	call read_FREE_iso(ar,md)
else if(kod_anomaly.eq.4)then
	write(*,*)' ISOTROPIC FREE ANOMALY IN LAYERS:'
	write(*,*)
	call read_FREE_iso(ar,md)
else if(kod_anomaly.eq.3)then
	write(*,*)' COMBINED ISOTROPIC ANOMALY: '
	call read_COMBI_iso(ar,md)
end if


31 continue
return
end