subroutine read_abs_INTERF(ar,md)
character*8 ar,md,line
character*5 fig,figg(10)
character*2 frm
real xcur(2000),ycur(2000),xcont(2000),ycont(2000)
real xlin(10,2000),ylin(10,2000),xper(10),yper(10)
integer nlin(10),kseg(10,100)
real xcross(10),ycross(10)

common/free_abs/vback,nan,xaa(40),yaa(40),vaa(40),xbb(40),ybb(40),vbb(40),anom(40,2000,2),nnod(40)
common/pi/pi,per
common/syn_start/ k_syn_start

iscale=0
coef_amp=1
if(k_syn_start.eq.1) then
	open(1,file='../../DATA/'//ar//'/'//md//'/velocity_start.dat')
else if(k_syn_start.eq.2) then
	open(1,file='../../DATA/'//ar//'/'//md//'/velocity_syn.dat')
else
	write(*,*)' k_syn_start is not defined:',k_syn_start
	pause
end if
do i=1,1000
	read(1,*,end=341)line	
	if(line.eq.'Scaling:')	goto 342		
end do
341 continue
!write(*,*)' cannot find SCALING'
goto 392

342	continue
read(1,*)fmap1,fmap2
read(1,*)tmap1,tmap2
read(1,*)rotate
read(1,*)coef_amp
iscale=1
sina=sin(rotate*per)
cosa=cos(rotate*per)
392 close(1)

if(k_syn_start.eq.1) then
	open(1,file='../../DATA/'//ar//'/'//md//'/velocity_start.dat')
else if(k_syn_start.eq.2) then
	open(1,file='../../DATA/'//ar//'/'//md//'/velocity_syn.dat')
else
	write(*,*)' k_syn_start is not defined:',k_syn_start
	pause
end if

read(1,*)   
read(1,*) 
read(1,*) vback
read(1,*) nform

open(25,file='../../FIG_files/syn_mod/all_contours.bln')

do iform=1,nform
	write(frm,'(i2)')iform
	read(1,*) 
	read(1,*) nlines
	do ilin=1,nlines
		read(1,'(a5)') fig
		figg(ilin)=fig
		open(2,file='../../DATA/'//ar//'/'//md//'/forms/'//fig//'.bln')
		read(2,*) nlin(ilin)
		!write(*,*) nlin(ilin)
		do i=1,nlin(ilin)
			read(2,*)xlin(ilin,i),ylin(ilin,i)
		end do
		close(2)
	end do
! Finding maximal distance:
	distmax=0
	do ilin=1,nlines
		x1=xlin(ilin,1)
		y1=ylin(ilin,1)
		x2=xlin(ilin,nlin(ilin))
		y2=ylin(ilin,nlin(ilin))
		dist=sqrt((x2-x1)**2+(y2-y1)**2)
		if(dist.gt.distmax) distmax=dist
	end do
	!write(*,*)' distmax=',distmax

! Extrapolate the ends of lines
	do ilin=1,nlines

		x1=xlin(ilin,1)
		y1=ylin(ilin,1)
		x2=xlin(ilin,2)
		y2=ylin(ilin,2)
		dist=sqrt((x2-x1)**2+(y2-y1)**2)
		if(dist.gt.distmax) distmax=dist
		xlin(ilin,1)=x1+((x1-x2)*(distmax/dist))
		ylin(ilin,1)=y1+((y1-y2)*(distmax/dist))

		x1=xlin(ilin,nlin(ilin)-1)
		y1=ylin(ilin,nlin(ilin)-1)
		x2=xlin(ilin,nlin(ilin))
		y2=ylin(ilin,nlin(ilin))
		dist=sqrt((x2-x1)**2+(y2-y1)**2)
		if(dist.gt.distmax) distmax=dist
		xlin(ilin,nlin(ilin))=x2+((x2-x1)*(distmax/dist))
		ylin(ilin,nlin(ilin))=y2+((y2-y1)*(distmax/dist))
556		continue
	end do

	do ilin=1,nlines
		fig=figg(ilin)
		!write(*,*)' fig=',fig
		do inod=1,nlin(ilin)
			x=xlin(ilin,inod)
			y=ylin(ilin,inod)
			!write(*,*)' x=',x,' y=',y
		end do
	end do
	

! Finding the intersections of lines

	kseg=0
	do ilin=1,nlines
		ilin1=ilin-1
		ilin2=ilin
		if(ilin.eq.1) ilin1=nlines
		icross=0
		do inod1=1,nlin(ilin1)-1
			x1=xlin(ilin1,inod1)
			y1=ylin(ilin1,inod1)
			x2=xlin(ilin1,inod1+1)
			y2=ylin(ilin1,inod1+1)
			do inod2=1,nlin(ilin2)-1
				x3=xlin(ilin2,inod2)
				y3=ylin(ilin2,inod2)
				x4=xlin(ilin2,inod2+1)
				y4=ylin(ilin2,inod2+1)
				!if(kseg(ilin1,inod1).ne.0.and.kseg(ilin2,inod2).ne.0) cycle
				if(abs(x1-x2).lt.0.001) then
					xpr=x1
					ypr=y3+((y4-y3)/(x4-x3))*(xpr-x3)
				else if(abs(x3-x4).lt.0.001) then
					xpr=x3
					ypr=y1+((y2-y1)/(x2-x1))*(xpr-x1)
				else
					A1=(y2-y1)/(x2-x1)
					B1=(x2*y1-x1*y2)/(x2-x1)
					A2=(y4-y3)/(x4-x3)
					B2=(x4*y3-x3*y4)/(x4-x3)
					if(abs(A1-A2).lt.0.00001) then
						!write(*,*)' the lines are parallel !!!'
						A1=A2+0.0001
						!pause
					end if
					xpr=(B2-B1) / (A1-A2)
					ypr=(A1*B2 - A2*B1) / (A1-A2)
				end if
				!write(*,*)' x=',xpr,' y=',ypr,' x1=',x1,' x2=',x2

				index=0
				if(ilin.gt.1) then
					do iii=1,ilin-1
						if(abs(xpr-xper(iii))+abs(ypr-yper(iii)).lt.0.01) index=1
					end do
				end if
				if(index.eq.1) cycle


				igood=0
				if(abs(x2-x1).gt.abs(y2-y1)) then
					if((xpr-x1)*(xpr-x2).le.0.) igood=igood+1
				else
					if((ypr-y1)*(ypr-y2).le.0.) igood=igood+1
				end if

				if(abs(x4-x3).gt.abs(y4-y3)) then
					if((xpr-x3)*(xpr-x4).le.0.) igood=igood+1
				else
					if((ypr-y3)*(ypr-y4).le.0.) igood=igood+1
				end if

				if(igood.eq.2) then
					icross=icross+1
					xcross(icross)=xpr
					ycross(icross)=ypr
				end if
			end do
		end do

		if(icross.eq.0) then
			write(*,*)' ilin1=',ilin1
			do i1=1,nlin(ilin1)
				x1=xlin(ilin1,i1)
				y1=ylin(ilin1,i1)
				write(*,*)' x1=',x1,' y1=',y1
			end do
			write(*,*)' ilin2=',ilin2
			do i2=1,nlin(ilin2)
				x2=xlin(ilin2,i2)
				y2=ylin(ilin2,i2)
				write(*,*)' x2=',x2,' y2=',y2
			end do
			write(*,*)' cannot find intesection'
			pause
		end if

		if(ilin.eq.1.and.icross.ne.1)then
			write(*,*)' Warning: ilin=',ilin,' icross=',icross
			write(*,*)' change the order of lines: iform=',iform
		end if

		if(ilin.ne.1)then
			x0=xper(ilin-1)	
			y0=yper(ilin-1)	
			dmin=9999999
			do i=1,icross
				x1=xcross(i)
				y1=ycross(i)
				dist=sqrt((x1-x0)*(x1-x0)+(y1-y0)*(y1-y0))
				if(abs(dist).lt.0.0001) cycle
				if(dist.lt.dmin) then
					imin=i
					dmin=dist
				end if
			end do
			xpr=xcross(imin)
			ypr=ycross(imin)
		else
			xpr=xcross(1)
			ypr=ycross(1)
		end if	

		xper(ilin)=xpr
		yper(ilin)=ypr
		!kseg(ilin1,inod1)=ilin2
		!kseg(ilin2,inod2)=ilin1

		!do iii=1,nlines
		!	if(figg(ilin1).eq.figg(iii)) kseg(iii,inod1)=kseg(ilin1,inod1)
		!	if(figg(ilin2).eq.figg(iii)) kseg(iii,inod2)=kseg(ilin2,inod2)
		!end do

		!write(*,*)
		!write(*,*)' fig=',figg(ilin1),' ilin1=',ilin1,' inod1=',inod1
		!write(*,*)' fig=',figg(ilin2),' ilin2=',ilin2,' inod2=',inod2
		!write(*,*)figg(ilin1),'  ',figg(ilin2),' xper=',xpr,' yper=',ypr

	end do

! creating the contour

	icont=0
	do ilin=1,nlines
		xpr1=xper(ilin)
		ypr1=yper(ilin)

		icont=icont+1
		xcont(icont)=xpr1
		ycont(icont)=ypr1

		ilin2=ilin+1
		if(ilin.eq.nlines) ilin2=1
		xpr2=xper(ilin2)
		ypr2=yper(ilin2)
		do inod=1,nlin(ilin)-1
			x1=xlin(ilin,inod)
			y1=ylin(ilin,inod)
			x2=xlin(ilin,inod+1)
			y2=ylin(ilin,inod+1)
			igood=0
			if(abs(x2-x1).gt.abs(y2-y1)) then
				if((xpr1-x1)*(xpr1-x2).gt.0.) cycle
				if((xpr1-x1)*(xpr1-x2).gt.0..and.(xpr2-x1)*(xpr2-x2).gt.0.) exit
				istep=1
				nstart=1
				nend=nlin(ilin)
				if((xpr1-x1)*(xpr2-x1).le.0.) then
					istep=-1
					nstart=nlin(ilin)
					nend=1
				end if
				do ii=nstart,nend,istep
					xx=xlin(ilin,ii)
					yy=ylin(ilin,ii)
					if((xx-xpr1)*(xx-xpr2).gt.0.) cycle
					icont=icont+1
					xcont(icont)=xx
					ycont(icont)=yy
				end do
				
			else
				if((ypr1-y1)*(ypr1-y2).gt.0.) cycle
				if((ypr1-y1)*(ypr1-y2).gt.0..and.(ypr2-y1)*(ypr2-y2).gt.0.) exit
				istep=1
				nstart=1
				nend=nlin(ilin)
				if((ypr1-y1)*(ypr2-y1).le.0.) then
					istep=-1
					nstart=nlin(ilin)
					nend=1
				end if
				do ii=nstart,nend,istep
					xx=xlin(ilin,ii)
					yy=ylin(ilin,ii)
					if((yy-ypr1)*(yy-ypr2).gt.0.) cycle
					icont=icont+1
					xcont(icont)=xx
					ycont(icont)=yy
				end do
			end if
		end do
	end do
	!do i=1,icont
	!	write(*,*)i,xcont(i),ycont(i)
	!end do
	!pause

	open(24,file='../../FIG_files/syn_mod/cont'//frm//'.bln')
	write(24,*)icont+1
	write(25,*)icont+1

	do i=1,icont
		anom(iform,i,1)=xcont(i)
		anom(iform,i,2)=ycont(i)
		write(24,*)anom(iform,i,1),anom(iform,i,2)
		write(25,*)anom(iform,i,1),anom(iform,i,2)
	end do
	nnod(iform)=icont+1
	anom(iform,nnod(iform),1)=xcont(1)
	anom(iform,nnod(iform),2)=ycont(1)
	write(24,*)xcont(1),ycont(1)
	write(25,*)xcont(1),ycont(1)
	close(24)


	read(1,*) xaa(iform),yaa(iform),vaa(iform)
	read(1,*) xbb(iform),ybb(iform),vbb(iform)

end do

close(25)


if(iscale.eq.1) then
	write(*,*)' rotate=',rotate,' sina=',sina,' cosa=',cosa
	xmin=99999
	xmax=-99999
	ymin=99999
	ymax=-99999
	do iform=1,nform
		!write(*,*)' nnod=',nnod(iform)
		do i=1,nnod(iform)
			x1=anom(iform,i,1)
			y1=anom(iform,i,2)
			x2=x1*cosa-y1*sina
			y2=x1*sina+y1*cosa
			anom(iform,i,1)=x2
			anom(iform,i,2)=y2
			if(x2.lt.xmin) xmin=x2
			if(x2.gt.xmax) xmax=x2
			if(y2.lt.ymin) ymin=y2
			if(y2.gt.ymax) ymax=y2
		end do
	end do
	write(*,*)' xmax=',xmax,' xmin=',xmin
	write(*,*)' ymax=',ymax,' ymin=',ymin

	do iform=1,nform
		!write(*,*)' nnod=',nnod(iform)
		do i=1,nnod(iform)
			x1=anom(iform,i,1)
			y1=anom(iform,i,2)

			x2=fmap1+((fmap2-fmap1)/(xmax-xmin))*(x1-xmin)
			y2=tmap1+((tmap2-tmap1)/(ymax-ymin))*(y1-ymin)

			anom(iform,i,1)=x2
			anom(iform,i,2)=y2
		end do
	end do
end if




nan=nform
write(*,*)' ABSOLUTE model with interfaces: nan=',nan
write(*,*)

return
end
