function velocity(x,y)
common/relief/nrlf,xrlf(10000),yrlf(10000),sea_lev,v_air,v_sea,v_min
common/kod_model/kod_abs, kod_anomaly

rlf = relieff(x)
sea = sea_lev

if(y.gt.sea.and.y.gt.rlf) then
	velocity=v_air
	return
end if

if(y.gt.rlf.and.y.le.sea) then
	velocity=v_sea
	return
end if


if(kod_abs.eq.1) then
	vabs=vrefmod(y)
else if(kod_abs.eq.2) then
	call abs_FREE_iso(x,y,vabs)
else if(kod_abs.eq.4) then
	call abs_FREE_iso(x,y,vabs)
else if(kod_abs.eq.3) then
	call SYN_VEL_2D(x,y,vabs)
else if(kod_abs.eq.5) then
	call VER_GRAD(x,y,vabs)
else if(kod_abs.eq.6) then
	call GRAD_LINES(x,y,vabs)
else
	write(*,*)' Absolute velocity model is not defined'
	pause
end if

!if(y.gt.10) vabs=300

!write(*,*)' kod_abs=',kod_abs,' vabs=',vabs


dv=0

if(kod_anomaly.ne.0) then
	call SYN_ISO_ANOM(x,y,dv)
end if

!write(*,*)' dv=',dv

velocity = vabs * (1. + dv/100.)


return
end
