subroutine read_surface(md)
character*8 md,line
character*5 surf(10),srf
integer ngood(100),ktmp(100)
real xtmp(100),ytmp(100)
common/interf/nsurf,nodsrf(10),xsurf(100,10),ysurf(100,10),ksurf(100,10)

open(1,file='../../DATA/'//md//'/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=553)line
	if(line.eq.'SURFACES') goto 554
end do
553 continue
write(*,*)' cannot find SURFACES in MAJOR_PARAM.DAT!!!'
pause
554 continue
read(1,*)nsurf
do i=1,nsurf
	read(1,'(a5)')surf(i)
	!write(*,*)surf(i)
end do

do isurf=1,nsurf

	srf=surf(isurf)
	open(2,file='../../DATA/'//md//'/forms/'//srf//'.bln')
	read(2,*) nodsrf(isurf)
	!write(*,*) nodsrf(isurf)
	do i=1,nodsrf(isurf)
		read(2,*)xsurf(i,isurf),ysurf(i,isurf)
		!write(*,*)xsurf(i,isurf),ysurf(i,isurf)
		!write(*,*)xsurf(i),ysurf(i)
	end do
	close(2)
end do

ksurf=0
do isurf=nsurf,2,-1
	!write(*,*)' isurf=',isurf
	do i1=1,nodsrf(isurf)
		xcur=xsurf(i1,isurf)
		ycur=ysurf(i1,isurf)
		do isurf2=isurf-1,1,-1
			xlim1=xsurf(1,isurf2)
			xlim2=xsurf(nodsrf(isurf2),isurf2)
			ylim1=ysurf(1,isurf2)
			ylim2=ysurf(nodsrf(isurf2),isurf2)
			if((xcur-xlim1)*(xcur-xlim2).ge.0) then
				x1=xlim1
				x2=xlim2
				y1=ylim1
				y2=ylim2
				ynext=y1+((y2-y1)/(x2-x1))*(xcur-x1)


			else
				do i2=2,nodsrf(isurf2)
					x1=xsurf(i2-1,isurf2)
					x2=xsurf(i2,isurf2)
					if((xcur-x1)*(xcur-x2).gt.0) cycle
					y1=ysurf(i2-1,isurf2)
					y2=ysurf(i2,isurf2)
					ynext=y1+((y2-y1)/(x2-x1))*(xcur-x1)
					exit
				end do
			end if
			if(ynext.lt.ycur) then
				ksurf(i1,isurf)=isurf2
				!write(*,*)' x=',xcur,' y=',ycur,ynext,ngood(i1)
				exit
			end if
		end do
	end do
	do i1=1,nodsrf(isurf)
		xcur=xsurf(i1,isurf)
		ycur=ysurf(i1,isurf)
		kcur=ksurf(i1,isurf)
		!write(*,*)' x=',xcur,' y=',ycur,' k=',kcur
	end do

	ntmp=1
	ktmp(1)=ksurf(1,isurf)
	xtmp(1)=xsurf(1,isurf)
	ytmp(1)=ysurf(1,isurf)

	do i1=2,nodsrf(isurf)
		k1=ksurf(i1-1,isurf)
		k2=ksurf(i1,isurf)

		if(k1.eq.0.and.k2.eq.0.or.k1.ne.0.and.k2.ne.0) goto 21

		x1=xsurf(i1-1,isurf)
		y1=ysurf(i1-1,isurf)
		x2=xsurf(i1,isurf)
		y2=ysurf(i1,isurf)

		isurf2=k1
		if(k1.eq.0) isurf2=k2

		do i2=2,nodsrf(isurf2)
			x3=xsurf(i2-1,isurf2)
			y3=ysurf(i2-1,isurf2)
			x4=xsurf(i2,isurf2)
			y4=ysurf(i2,isurf2)

			if(abs(x1-x2).lt.0.001) then
				xpr=x1
				ypr=y3+((y4-y3)/(x4-x3))*(xpr-x3)
			else if(abs(x3-x4).lt.0.001) then
				xpr=x3
				ypr=y1+((y2-y1)/(x2-x1))*(xpr-x1)
			else
				A1=(y2-y1)/(x2-x1)
				B1=(x2*y1-x1*y2)/(x2-x1)
				A2=(y4-y3)/(x4-x3)
				B2=(x4*y3-x3*y4)/(x4-x3)
				if(abs(A1-A2).lt.0.00001) then
					write(*,*)' the lines are parallel !!!'
					pause
				end if
				xpr=(B2-B1) / (A1-A2)
				ypr=(A1*B2 - A2*B1) / (A1-A2)
			end if
			!write(*,*)' x=',xper,' y=',yper
			igood=0
			if(abs(x2-x1).gt.abs(y2-y1)) then
				if((xpr-x1)*(xpr-x2).le.0.) igood=igood+1
			else
				if((ypr-y1)*(ypr-y2).le.0.) igood=igood+1
			end if

			if(abs(x4-x3).gt.abs(y4-y3)) then
				if((xpr-x3)*(xpr-x4).le.0.) igood=igood+1
			else
				if((ypr-y3)*(ypr-y4).le.0.) igood=igood+1
			end if
			if(igood.eq.2) exit
		end do
		ntmp=ntmp+1
		ktmp(ntmp)=0
		xtmp(ntmp)=xpr
		ytmp(ntmp)=ypr
		!write(*,*)' x1=',x1,' x2=',x2,' y1=',y1,' y2=',y2
		!write(*,*)' x3=',x3,' x4=',x4,' y3=',y3,' y4=',y4
		!write(*,*)' xpr=',xpr,' ypr=',ypr

21		continue
		ntmp=ntmp+1
		ktmp(ntmp)=k2
		xtmp(ntmp)=xsurf(i1,isurf)
		ytmp(ntmp)=ysurf(i1,isurf)

	end do
	!write(*,*)' isurf=',isurf,' n=',ntmp
	do i=1,ntmp
		!write(*,*)xtmp(i),ytmp(i),ktmp(i)
		ksurf(i,isurf)=ktmp(i)
		xsurf(i,isurf)=xtmp(i)
		ysurf(i,isurf)=ytmp(i)
	end do
	nodsrf(isurf)=ntmp
	
end do
!pause

open(21,file='interfaces.bln')
do isurf=1,nsurf
	do i1=2,nodsrf(isurf)
		k1=ksurf(i1-1,isurf)
		k2=ksurf(i1,isurf)

		if(k1.ne.0.or.k2.ne.0) cycle

		x1=xsurf(i1-1,isurf)
		y1=ysurf(i1-1,isurf)
		x2=xsurf(i1,isurf)
		y2=ysurf(i1,isurf)
		write(21,*)2
		write(21,*)x1,y1
		write(21,*)x2,y2
		
	end do

end do


return
end
