subroutine refr_ray_rough(xzt,yzt,xst,yst,isrf,	time)
real xs_best(100),ys_best(100),ss_best(100)
integer isrf_best(100)

common/ray_lin_srf/nseg,nod_refl,xseg(100),yseg(100),sseg(100),isrfseg(100)
common/lin_bend_param/segm_min_refr,bend_lin_max,bend_lin_min


sign=(xst-xzt)/abs(xst-xzt)
iicur=0

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Preliminary reflected ray, as two line:

call yyy_interface(xzt,isrf, ybnce1,kod)
call yyy_interface(xst,isrf, ybnce2,kod)

xbnce1=xzt + bend_lin_max * sign
xbnce2=xst - bend_lin_max * sign

call ray_refr_segm(xzt,yzt,xbnce1,ybnce1,xbnce2,ybnce2,xst,yst,isrf,time)


tbest=time
xbest1=xbnce1
ybest1=ybnce1
xbest2=xbnce2
ybest2=ybnce2

!open(21,file='ray_start.bln')
!write(21,*)nseg
!do i=1,nseg
!	write(21,*)xseg(i),yseg(i)
	!write(*,*)xseg(i),yseg(i),isrfseg(i)
!end do
!close(21)

!write(*,*)' First approxim: time=',time



bend_cur = bend_lin_max

index1=1
index2=1

123 continue

if(index1.ne.0) then
	xbnce1 = xbest1 + bend_cur * sign
	xbnce2 = xbest2
	call yyy_interface(xbnce1,isrf, ybnce1,kod)
	ybnce2 = ybest2
	call ray_refr_segm(xzt,yzt,xbnce1,ybnce1,xbnce2,ybnce2,xst,yst,isrf,time)
	!write(*,*)' 1: xbnce1=',xbnce1,' xbnce2=',xbnce2,' time=',time
	if(time.lt.tbest) then
		tbest=time
		xbest1=xbnce1
		ybest1=ybnce1
		xbest2=xbnce2
		ybest2=ybnce2
		n_best=nseg
		xs_best=xseg
		ys_best=yseg
		ss_best=sseg
		isrf_best=isrfseg
	else
		index1=0
	end if
end if


if(index2.ne.0) then
	xbnce1 = xbest1
	xbnce2 = xbest2 - bend_cur * sign
	call yyy_interface(xbnce2,isrf, ybnce2,kod)
	ybnce1 = ybest1
	call ray_refr_segm(xzt,yzt,xbnce1,ybnce1,xbnce2,ybnce2,xst,yst,isrf,time)
	!write(*,*)' 2: xbnce1=',xbnce1,' xbnce2=',xbnce2,' time=',time
	if(time.lt.tbest) then
		tbest=time
		xbest1=xbnce1
		ybest1=ybnce1
		xbest2=xbnce2
		ybest2=ybnce2
		n_best=nseg
		xs_best=xseg
		ys_best=yseg
		ss_best=sseg
		isrf_best=isrfseg
	else
		index2=0
	end if
end if

if(index1.ne.0.or.index2.ne.0) goto 123

nseg=n_best
xseg=xs_best
yseg=ys_best
sseg=ss_best
isrfseg=isrf_best
time=tbest

!write(*,*)' 2: xbest1=',xbest1,' xbest2=',xbest2,' tbest=',tbest
!open(21,file='ray_cur.bln')
!write(21,*)nseg
!do i=1,nseg
	!write(21,*)xseg(i),yseg(i)
	!write(*,*)i,xseg(i),yseg(i),isrfseg(i)
!end do
!close(21)
		
time2 = time_lin_srf()

!write(*,*)' time2=',time2,' time=',time

return
end 