character*8 ar,md,line
character*2 it,it0

real dt_ztcor(1000)

common/ray_param/ds_ini,ds_segm_min,bend_min0,bend_max0
common/refmod/nref,href(600),vref(600)
common/nanom/n_anomaly
common/ray_xyv/nodes,xray(10000),yray(10000),vray(10000),sray(10000)
common/surface/nsurf,xsurf(100),ysurf(100)
common/param_reg_bend/step,segm_min,bendreg_min,bendreg_max
common/pi/pi,per
common/param_sea_bend/bendsurf_max,bendsurf_min,dy_deeper
common/syn_start/ k_syn_start

common/relief/nrlf,xrlf(10000),yrlf(10000),sea_lev,v_air,v_sea,v_min

one=1.e0
pi=asin(one)*2.e0
per=pi/180.e0
k_syn_start=1


bendsurf_max=3
bendsurf_min=0.05

kod_syn=0
open(1, file='../../model.dat')
read(1,'(a8)')ar
read(1,'(a8)')md
read(1,*)iter
28 close(1)

write(*,*)' area=',ar,' model=',md,' iter=',iter

open(1,file='../../DATA/'//ar//'/'//md//'/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=563)line
	if(line.eq.'GENERAL ') goto 564
end do
563 continue
write(*,*)' cannot find GENERAL INFORMATION in MAJOR_PARAM.DAT!!!'
pause
564 continue
read(1,*)key_1real_2syn
read(1,*)niter
close(1)

key_preview=0
open(1,file='../../preview_key.txt')
read(1,*,end=771)key_preview
771 close(1)

if(key_preview.ne.0) then
	i=system('mkdir -p ../../PICS/ps/'//ar//'/'//md)
	i=system('mkdir -p ../../PICS/png/'//ar//'/'//md)

	open(1,file='../../DATA/'//ar//'/set_vis.dat')
	read(1,*) xmap1,xmap2,dxmap  
	read(1,*) ymap1,ymap2,dymap  
	close(1)


end if




write(it,'(i2)')iter
write(it0,'(i2)')iter-1

call read_ISO_ABS(ar,md)
call read_ISO_ANOM(ar,md)

call prepare_mod_2d(ar,md,iter-1)


!******************************************************************
nrlf=0
sea_lev=0
v_air=0.01
v_sea=0.01
v_min=0.1
open(1,file='../../DATA/'//ar//'/inidata/relief.bln',status='old',err=992)
read(1,*,end=92)nrlf,sea_lev,v_air,v_sea,v_min
do irlf=1,nrlf
	read(1,*)xrlf(irlf),yrlf(irlf)
end do
92 close(1)
992 continue

!do xx=0.,200.,10.
!	x=xx
!	h=relieff(x)
!	write(*,*)' x=',x,' h=',h
!end do
!pause


!x=40
!do y=0.,-20.,-1.
!x=160
!y=170
!v= velocity(x,y)
!write(*,*)' y=',y,' v=',v
!end do
!pause


!******************************************************************
open(1,file='../../DATA/'//ar//'/'//md//'/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=553)line
	if(line.eq.'REG.BEND') goto 554
end do
553 continue
write(*,*)' cannot find REG.BENDING PARAMETERS in MAJOR_PARAM.DAT!!!'
pause
554 continue
read(1,*)step
read(1,*)segm_min
read(1,*)bendreg_min
read(1,*)bendreg_max
read(1,*)ifreq_screen
read(1,*)ifreq_ray
read(1,*)res_max
read(1,*)it_limit,res_max_it
read(1,*)disbot_min
close(1)

if(iter.ge.it_limit) res_max = res_max_it

write(*,*)' iter=',iter,' res_max=',res_max

!******************************************************************
K_ztcor=0
nzt=0
open(1,file='../../DATA/'//ar//'/'//md//'/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=513)line
	if(line.eq.'SOURCE C') goto 514
end do
514 continue
read(1,*)w_ztcor
if(w_ztcor.gt.0.00001) K_ztcor=1
513 close(1)
!write(*,*)
if(K_ztcor.eq.1.and.iter.gt.1) then
	open(1,file='../../DATA/'//ar//'/'//md//'/data/ztr_cor'//it0//'.dat')
	read(1,*)nzt
	do izt=1,nzt
		read(1,*)dt_ztcor(izt)
		!write(*,*)dt_ztcor(izt)
	end do
	close(11)
end if
!******************************************************************



!write(*,*)ds_ini,ds_part_min,val_bend_min,bend_max0

if(iter.eq.1.and.key_1real_2syn.eq.1) then
	open(1,file='../../DATA/'//ar//'/inidata/rays0.dat')
else
	open(1,file='../../DATA/'//ar//'/'//md//'/data/rays'//it0//'.dat',form='binary')
	if(K_ztcor.eq.1)open(2,file='../../tmp/cod_ztr'//it0//'.dat',form='binary')
end if

open(11,file='../../DATA/'//ar//'/'//md//'/data/rays'//it//'.dat',form='binary')
open(12,file='../../tmp/paths'//it//'.dat',form='binary')
open(41,file='../../FIG_files/rays/rays'//it//'.bln')
open(42,file='../../FIG_files/rays/godog'//it//'.dat')
open(43,file='../../FIG_files/rays/godog_zt'//it//'.dat')
open(44,file='../../FIG_files/rays/godog_st'//it//'.dat')

disp0=0
disp1=0
nbad=0
nray=0
nr0=0

1	continue
	if(iter.eq.1.and.key_1real_2syn.eq.1) then
		read(1,*,end=2) xzt,yzt,xst,yst,tobs
	else
		read(1,end=2) xzt,yzt,xst,yst,tobs,tmod0
		dt0=tobs-tmod0
		if(K_ztcor.eq.1)then
			read(2)izt
			tobs = tobs - dt_ztcor(izt)
			!write(*,*)' izt=',izt,' dt_ztcor=',dt_ztcor(izt)
			dtcorr=tobs-tmod0
			!write(*,*)' dt0=',dt0,' dtcorr=',dtcorr
		end if
	end if
	nr0=nr0+1
	!if(nr0.gt.100) goto 2


!	write(*,*)' xst=',xst,' yst=',yst
!	write(*,*)' xzt=',xzt,' yzt=',yzt

	if(abs(xzt-xst).lt.disbot_min) then
		nbad=nbad+1
		goto 1
	end if


	call trace_1_arrival_sea(xzt,yzt,xst,yst,	xzt_bot,yzt_bot,tmod)
!	write(*,*)' nr0=',nr0,' tmod=',tmod
!if(mod(nr0,10).eq.0)	write(*,*)' tobs=',tobs,' tmod=',tmod,' nodes=',nodes
!	write(*,*)' nodes=',nodes
!	do i=1,nodes
!		v=velocity(xray(i),yray(i))
!		write(*,*)' xray=',xray(i),' yray=',yray(i),v
!	end do
!	pause


	if(abs(xzt_bot-xst).lt.disbot_min) then
		nbad=nbad+1
		goto 1
	end if




	!write(*,*)' tobs=',tobs,' tmod=',tmod,' dt=',tobs-tmod

	if(abs(tmod-tobs).gt.res_max) then
		nbad=nbad+1
		goto 1
	end if
		
	disp0=disp0+abs(dt0)


	nray=nray+1

	dt1=tobs-tmod
	disp1=disp1+abs(dt1)

	!red=100*(disp0-disp1)/disp0

	!write(*,*)' dt1=',dt1,' red=',red
	!pause

	write(42,*)abs(xzt-xst),tmod
	write(43,*)xzt,tmod
	write(44,*)xst,tmod
	write(11)xzt,yzt,xst,yst,tobs,tmod
	write(12)nodes
	do i=1,nodes
		write(12)xray(i),yray(i)
	end do

	if(mod(nray,ifreq_ray).eq.0) then
		write(41,*)nodes+1
		write(41,*)xzt,yzt
		do i=1,nodes
			write(41,*)xray(i),yray(i)
		end do
	end if

	if(mod(nray,ifreq_screen).eq.0) then
		disp_cur=disp1/nray
		if(iter.eq.1) then
			write(*,34)nray,nr0,abs(xzt-xst),tobs,tmod,dt1,disp_cur
34 format(2i5,' dist=',f8.1,' tobs=',f10.3,' tmod=',f10.3,'   dt=',f10.3,' disp=',f10.3)
		else
			red=100*(disp0-disp1)/disp0
			write(*,*)nr0,' dt=',(tobs-tmod),' red=',red,' disp=',disp_cur
		end if
	end if
	goto 1
2 close(1)
close(11)
close(12)
close(42)
close(41)

write(*,*)' nbad=',nbad,' nray=',nray

if(key_preview.eq.0) stop

!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************


stop
end
