character*8 ar,md,line
character*1 gr
character*2 it,it0
real ornt(10)
real xray0(10000),yray0(10000),xray(15000),yray(15000)
allocatable xgrd(:),ygrd(:),amat1(:)
real yline(400,400),xline(400),amat_line(2000)
integer non_ln(400),kline(400,400),kmat_line(2000)

real xnod4(4),ynod4(4)
integer knod4(4)
real xsurf(100),ysurf(100)
real xzt_all(1000),yzt_all(1000)

common/refmod/nref,href(600),vref(600)
common/relief/nrlf,xrlf(10000),yrlf(10000),sea_lev,v_air,v_sea,v_min
common/vsea/vsea
common/syn_start/ k_syn_start

one=1.d0
pi=asin(one)*2.d0
per=pi/180.d0

dist_porog=0.1
k_syn_start=1
dv_unit=1

open(1,file='../../model.dat')
read(1,'(a8)')ar
read(1,'(a8)')md
read(1,*)iter
close(1)
write(it,'(i2)')iter
write(it0,'(i2)')iter-1

write(*,*)' md=',md,' iter=',iter


call read_ISO_ABS(ar,md)
call read_ISO_ANOM(ar,md)


call prepare_mod_2d(ar,md,iter-1)

nrlf=0
sea_lev=0
v_air=0.01
v_sea=1.0
v_min=1
open(1,file='../../DATA/'//ar//'/inidata/relief.bln',status='old',err=992)
read(1,*,end=92)nrlf,sea_lev,v_air,v_sea,v_min
do irlf=1,nrlf
	read(1,*)xrlf(irlf),yrlf(irlf)
end do
92 close(1)
992 continue

!******************************************************************
open(1,file='../../DATA/'//ar//'/'//md//'/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=533)line
	if(line.eq.'GRID_PAR') goto 534
end do
533 continue
write(*,*)' cannot find GRID_PARAMETERS in MAJOR_PARAM.DAT!!!'
pause
534 continue
read(1,*)xlim1,xlim2,dxpl
read(1,*)ylim1,ylim2,dypl
read(1,*)n_parts
close(1)
nxpl=int_best((xlim2-xlim1)/dxpl)+1
nypl=int_best((ylim2-ylim1)/dypl)+1
xlim2=xlim1+nxpl*dxpl
ylim2=ylim1+nypl*dypl

!******************************************************************


open(1,file='../../DATA/'//ar//'/'//md//'/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=553)line
	if(line.eq.'REG.BEND') goto 554
end do
553 continue
write(*,*)' cannot find REG.BENDING PARAMETERS in MAJOR_PARAM.DAT!!!'
pause
554 continue
read(1,*) 
read(1,*) 
read(1,*) 
read(1,*) 
read(1,*) 
read(1,*)
read(1,*)res_max
close(1)

!******************************************************************

K_ztcor=0

open(1,file='../../DATA/'//ar//'/'//md//'/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=513)line
	if(line.eq.'SOURCE C') goto 514
end do
514 continue
read(1,*)w_ztcor
if(w_ztcor.gt.0.00001) K_ztcor=1
513 close(1)


if(K_ztcor.eq.1) then
	open(1,file='../../DATA/'//ar//'/'//md//'/data/rays'//it//'.dat',form='binary')
	open(11,file='../../tmp/cod_ztr'//it//'.dat',form='binary')
	16 read(1,end=26) xzt,yzt,xst,yst,tobs,tmod
		if(nzt.ne.0) then
			do izt=1,nzt
				x=xzt_all(izt)
				y=yzt_all(izt)
				dist=sqrt((x-xzt)**2+(y-yzt)**2)
				if(dist.lt.dist_porog) goto 36
			end do
		end if
		nzt=nzt+1
		xzt_all(nzt)=xzt
		yzt_all(nzt)=yzt
		izt=nzt
	36  continue
		write(11)izt
	goto 16
	26 close(1)
	close(11)


	open(11,file='../../DATA/'//ar//'/'//md//'/data/ztr'//it//'.dat')
	write(11,*)nzt
	do izt=1,nzt
		write(11,*)xzt_all(izt),yzt_all(izt)
	end do
	close(11)
end if

!write(*,*)' K_ztcor=',K_ztcor

!******************************************************************
open(1,file='../../DATA/'//ar//'/'//md//'/data/grid.dat')
read(1,*)node
nparam=node
write(*,*)' node=',node,' nparam=',nparam
allocate(xgrd(node),ygrd(node),amat1(nparam))
do i=1,node
	read(1,*)xgrd(i),ygrd(i)
end do
close(1)



kline=0
nline=1
non_ln(nline)=2
xline(nline)=xlim1
yline(nline,1)=ylim1
yline(nline,2)=ylim2
do ix=1,nxpl
	xln=xlim1+(ix-0.5)*dxpl
	nline=nline+1

	nonln=1
	yline(nline,1)=ylim1

	do inod=1,node
		xxx=xgrd(inod)
		if(abs(xxx-xln).gt.0.001) cycle
		yyy=ygrd(inod)
		nonln=nonln+1
		yline(nline,nonln)=yyy
		kline(nline,nonln)=inod
	end do
	nonln=nonln+1
	yline(nline,nonln)=ylim2
	non_ln(nline)=nonln
	xline(nline)=xln
end do
nline=nline+1
non_ln(nline)=2
xline(nline)=xlim2
yline(nline,1)=ylim1
yline(nline,2)=ylim2

!write(*,*)' nline=',nline


nray=0
nonz_tot=0

open(11,file='../../tmp/matr'//it//'.dat',form='binary')

open(1,file='../../DATA/'//ar//'/'//md//'/data/rays'//it//'.dat',form='binary')
open(2,file='../../tmp/paths'//it//'.dat',form='binary')

1 read(1,end=2) xzt,yzt,xst,yst,tobs,tmod
	res=tobs-tmod
!	if(abs(res).gt.res_max) goto 1
	amat_line=0
	kmat_line=0

	nray=nray+1
	read(2)nodes0
	do i=1,nodes0
		read(2)xray0(i),yray0(i)
	end do

!	if(nray.ne.94) goto 1


	nodes=1
	xray(1)=xray0(1)
	yray(1)=yray0(1)

	do i=1,nodes0-1
		x1=xray0(i)
		y1=yray0(i)
		x2=xray0(i+1)
		y2=yray0(i+1)
		sqr=(x2-x1)**2+(y2-y1)**2
		if(sqr.lt.abs(dypl/1000.))cycle
		ds=sqrt(sqr)
		dss=ds/n_parts
		do ii=1,n_parts
			nodes=nodes+1
			xray(nodes)=x1+((x2-x1)/ds)*(dss*ii)
			yray(nodes)=y1+((y2-y1)/ds)*(dss*ii)
		end do
	end do
	!write(*,*)nray,nodes,nodes0
	!if(nray.lt.10338) goto 1

	if(mod(nray,500).eq.0) write(*,*)nray,nodes,res

	amat1=0.
	do ip=2,nodes
		xl1=xray(ip-1)
		xl2=xray(ip)
		yl1=yray(ip-1)
		yl2=yray(ip)
		dss=sqrt((xl1-xl2)*(xl1-xl2)+(yl1-yl2)*(yl1-yl2))

		xmid=(xl1+xl2)/2.
		ymid=(yl1+yl2)/2.
		vmid=velocity(xmid,ymid)

		if(vmid.le.v_min) cycle
!		write(*,*)' xmid=',xmid,' ymid=',ymid,' vmid=',vmid


		!if((xmid-xlim1)*(xmid-xlim2).gt.0) cycle
		!if((ymid-ylim1)*(ymid-ylim2).gt.0) cycle

		do ix=1,nline-1
			x1=xline(ix)
			x2=xline(ix+1)
			if((xmid-x1)*(xmid-x2).le.0) goto 221
		end do
		cycle

221		continue

		do iy1=1,non_ln(ix)-1
			y11=yline(ix,iy1)
			y12=yline(ix,iy1+1)
			k11=kline(ix,iy1)
			k12=kline(ix,iy1+1)
			if((ymid-y11)*(ymid-y12).le.0) exit
		end do

		do iy2=1,non_ln(ix+1)-1
			y21=yline(ix+1,iy2)
			y22=yline(ix+1,iy2+1)
			k21=kline(ix+1,iy2)
			k22=kline(ix+1,iy2+1)
			if((ymid-y21)*(ymid-y22).le.0) exit
		end do
		!write(*,*)' xmid=',xmid,' x1=',x1,' x2=',x2
		!write(*,*)' ymid=',ymid,' y11=',y11,' y12=',y12
		!write(*,*)' ymid=',ymid,' y21=',y21,' y22=',y22


		if(k11.ne.0) then
			dv11=dv_unit
			dv12=0
			dv1=dv11+((dv12-dv11)/(y12-y11))*(ymid-y11)
			dv2=0
			dvmid=dv1+((dv2-dv1)/(x2-x1))*(xmid-x1)
			!write(*,*)' dvmid=',dvmid
			!dmatr=-1.e6 * dvmid*dss/(vmid**2 * dv_unit)
			dmatr= -dvmid*dss/(vmid**2 * dv_unit)
			!write(*,*)' k11=',k11,' dvmid=',dvmid,' dmatr=',dmatr
			amat1(k11)=amat1(k11)+dmatr
		end if

		if(k12.ne.0) then
			dv11=0
			dv12=dv_unit
			dv1=dv11+((dv12-dv11)/(y12-y11))*(ymid-y11)
			dv2=0
			dvmid=dv1+((dv2-dv1)/(x2-x1))*(xmid-x1)
			!dmatr=-1.e6 * dvmid*dss/(vmid**2 * dv_unit)
			dmatr= -dvmid*dss/(vmid**2 * dv_unit)
			!write(*,*)' k12=',k12,' dvmid=',dvmid,' dmatr=',dmatr
			amat1(k12)=amat1(k12)+dmatr
		end if

		if(k21.ne.0) then
			dv21=dv_unit
			dv22=0
			dv2=dv21+((dv22-dv21)/(y22-y21))*(ymid-y21)
			dv1=0
			dvmid=dv1+((dv2-dv1)/(x2-x1))*(xmid-x1)
			!dmatr=-1.e6 * dvmid*dss/(vmid**2 * dv_unit)
			dmatr= -dvmid*dss/(vmid**2 * dv_unit)
			!write(*,*)' k21=',k21,' dvmid=',dvmid,' dmatr=',dmatr
			amat1(k21)=amat1(k21)+dmatr
		end if

		if(k22.ne.0) then
			dv21=0
			dv22=dv_unit
			dv2=dv21+((dv22-dv21)/(y22-y21))*(ymid-y21)
			dv1=0
			dvmid=dv1+((dv2-dv1)/(x2-x1))*(xmid-x1)
			if(dvmid.gt.dv_unit) then
				write(*,*)' dv2=',dv2
				write(*,*)' y21=',y21,' y22=',y22,' ymid=',ymid
				write(*,*)' x1=',x1,' x2=',x2,' xmid=',xmid
				pause
			end if
			!dmatr=-1.e6 * dvmid * dss / (vmid**2 * dv_unit)
			dmatr= -dvmid * dss / (vmid**2 * dv_unit)
			!write(*,*)' k22=',k22,' dvmid=',dvmid,' dmatr=',dmatr
			amat1(k22)=amat1(k22)+dmatr
		end if
	end do

	nonz=0
	do i=1,nparam
		if(abs(amat1(i)).lt.1.e-15) cycle
		nonz=nonz+1
		amat_line(nonz)=amat1(i)
		kmat_line(nonz)=i
		!write(*,*)nonz,i,amat1(i)
	end do
	write(11)nonz,res
	do i=1,nonz
		write(11)amat_line(i),kmat_line(i)
		!write(*,*)amat_line(i),kmat_line(i)
	end do

	nonz_tot = nonz_tot + nonz

	goto 1

2 close(1)
close(2)
write(*,*)' nray=',nray
close(11)

open(11,file='../../DATA/'//ar//'/'//md//'/data/numbers'//it//'.dat')
write(11,*)nray,nonz_tot,node,nparam
close(11)


stop
end
