character*8 ar,md,line
character*1 gr
character*2 it,it0
real amat_line(1000)
integer kmat_line(1000)
real xsurf(100),ysurf(100)

allocatable x(:),x0(:),u(:),v(:),w(:),aaa(:),dt(:),xmod(:)
allocatable ncolrow(:),ncol(:)
allocatable xgrd(:),ygrd(:)

common/refmod/nref,href(600),vref(600)
common/syn_start/ k_syn_start
common/relief/nrlf,xrlf(10000),yrlf(10000),sea_lev,v_air,v_sea,v_min

scale=1
k_syn_start=1

open(1,file='../../model.dat')
read(1,'(a8)')ar
read(1,'(a8)')md
read(1,*)iter
close(1)
write(it,'(i2)')iter
write(it0,'(i2)')iter-1

write(*,*)' area=',ar,' model=',md,' iter=',iter

!******************************************************************
open(1,file='../../DATA/'//ar//'/'//md//'/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=533)line
	if(line.eq.'INVERSIO') goto 534
end do
533 continue
write(*,*)' cannot find INVERSION PARAMETERS in MAJOR_PARAM.DAT!!!'
pause
534 continue
read(1,*)iter_lsqr
read(1,*)sm_vel
read(1,*)rg_vel
write(*,*)' smoothing=',sm_vel,' regul=',rg_vel
close(1)

!******************************************************************
K_ztcor=0
nzt=0
open(1,file='../../DATA/'//ar//'/'//md//'/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=513)line
	if(line.eq.'SOURCE C') goto 514
end do
514 continue
read(1,*)w_ztcor
if(w_ztcor.gt.0.00001) K_ztcor=1
513 close(1)
!write(*,*)
if(K_ztcor.eq.1) then
	open(1,file='../../DATA/'//ar//'/'//md//'/data/ztr'//it//'.dat')
	read(1,*)nzt
	close(1)
	write(*,*)' K_ztcor=',K_ztcor,' nzt=',nzt
end if
!******************************************************************


call read_ISO_ABS(ar,md)
call read_ISO_ANOM(ar,md)

nrlf=0
sea_lev=0
v_air=0.01
v_sea=1.0
v_min=1
open(1,file='../../DATA/'//ar//'/inidata/relief.bln',status='old',err=992)
read(1,*,end=92)nrlf,sea_lev,v_air,v_sea,v_min
do irlf=1,nrlf
	read(1,*)xrlf(irlf),yrlf(irlf)
end do
92 close(1)
992 continue


open(1,file='../../DATA/'//ar//'/'//md//'/data/numbers'//it//'.dat')
read(1,*)nray,nonz,nvel,npar
write(*,*)nray,nonz,nvel,npar
close(1)

nonzer=nonz
if(K_ztcor.eq.1) then
	nonzer=nonz+nray
end if

nc = npar + nzt
nrows = nray

write(*,*)' nray=',nray,' nonzer=',nonzer,' nc=',nc

if(sm_vel.gt.0.0001) then
	open(1,file='../../DATA/'//ar//'/'//md//'/data/otr.dat')
	read(1,*) notr
	close(1)
	nonzer = nonzer + notr * 2
	nrows = nrows + notr
end if

if(rg_vel.gt.0.0001) then
	nonzer = nonzer + nvel
	nrows = nrows + nvel
end if

!write(*,*)' nrows=',nrows,' nonzer=',nonzer

allocate(xmod(nc),x(nc),x0(nc),v(nc),w(nc))
allocate(ncol(nrows),dt(nrows),u(nrows))
allocate(aaa(nonzer),ncolrow(nonzer))

!open(1,file='../../tmp/matr'//it//'.dat',form='binary')
!ir=0
!nonz=0
!avmat=0
!avdt=0

!143	continue
!	read(1,end=142)nuz,res
!	avdt=avdt+abs(res)
!	ir=ir+1
!	do i=1,nuz
!		read(1)amat_line(i),kmat_line(i)
!		nonz=nonz+1
!		avmat=avmat+abs(amat_line(i))
		!write(*,*)amat_line(i),kmat_line(i)
!	end do
!	goto 143
!142 close(1)
!avmat=avmat/nonz
!avdt=avdt/ir
!avmat=1
!write(*,*)' avmat=',avmat,' nonz=',nonz
!write(*,*)' avdt=',avdt,' ir=',ir


open(1,file='../../tmp/matr'//it//'.dat',form='binary')
if(K_ztcor.eq.1)open(2,file='../../tmp/cod_ztr'//it//'.dat',form='binary')
ir=0
nonz=0

43	continue
	read(1,end=42)nuz,res
	if(K_ztcor.eq.1)read(2)izt
	do i=1,nuz
		read(1)amat_line(i),kmat_line(i)
		!write(*,*)amat_line(i),kmat_line(i)
	end do
	ir=ir+1
	dt(ir)=res		!!!!!!!!!!!!!!!!!!!!!!!!!
	!write(*,*)' dt(ir)=',dt(ir)
	ncol(ir) = nuz 
	do ii=1,nuz
		nonz=nonz+1
		if(kmat_line(ii).le.nvel) then
			aaa(nonz) = amat_line(ii)
		else
			write(*,*)' kmat_line(ii)=',kmat_line(ii)
			pause
		end if
		ncolrow(nonz)= kmat_line(ii)
	end do
	if(K_ztcor.eq.1)then
		nonz=nonz+1
		!write(*,*)' nonz=',nonz
		ncolrow(nonz)= nvel + izt
		aaa(nonz) = w_ztcor
		ncol(ir) = ncol(ir)+1 
	end if
	goto 43
42 close(1)

write(*,*)' nray=',ir,' nonz=',nonz


if(sm_vel.gt.0.0001) then
	open(1,file='../../DATA/'//ar//'/'//md//'/data/otr.dat')
	read(1,*) notr
	do i=1,notr
		read(1,*) ipar1,ipar2
		ir=ir+1
		dt(ir)=0.
		ncol(ir)=2

		nonz=nonz+1
		aaa(nonz)=sm_vel
		ncolrow(nonz) = ipar1

		nonz=nonz+1
		aaa(nonz)=-sm_vel
		ncolrow(nonz) = ipar2

	end do
end if

if(rg_vel.gt.0.0001) then
	do i=1,nvel 
		ir=ir+1
		dt(ir)=0.
		ncol(ir)=1
		nonz=nonz+1
		aaa(nonz)=rg_vel
		ncolrow(nonz)= i
	end do
end if

write(*,*)' nray=',ir,' nonz=',nonz

nz=nonz
nr=ir

do i=1,nr
	u(i)=dt(i)
end do


kount=0
do irw=1,nr
	!write(*,*)' irw=',irw,' dt=',u(irw)
	do ii=1,ncol(irw)
		kount=kount+1
		nn=ncolrow(kount)
		!write(*,*)' nn=',nn,' aaa=',aaa(kount)
		if(abs(u(irw)).gt.1.e10) then
			write(*,*)' Warning!!!'
			write(*,*)' dt=',u(irw)
			pause
		end if
		if(abs(aaa(kount)).gt.1.e10) then
			write(*,*)' Warning!!!'
			write(*,*)' irw=',irw,' nn=',nn
			write(*,*)' aaa=',aaa(kount)
			pause
		end if
		if(nn.le.0.or.nn.gt.nc) then
			write(*,*)' Warning!!!'
			write(*,*)' irw=',irw,' nn=',nn
			pause
		end if
	end do
end do
write(*,*)' N rows=',nr,' N columns=',nc,' N nonzer=',nz
write(*,*)

!*******************************************************
!*******************************************************
!*******************************************************
call pstomo(nr,nc,x,u,v,w,iter_lsqr,nz,aaa,ncolrow,ncol)
!*******************************************************
!*******************************************************
!*******************************************************

err=0
kount=0
avres=0.
avres0=0.
dtvel=0
dtsta=0
dtztr=0
!write(*,*)' nray=',nray
do irw=1,nray
	dt1=0
	do ii=1,ncol(irw)
		kount=kount+1
		nn=ncolrow(kount)
		!if(nn.gt.nvel) cycle
		!if(nn.eq.284)then
		!write(*,*)nn,aaa(kount)*x(nn)
		!end if
		dt1=dt1+aaa(kount)*x(nn)
	end do
	avres=avres+abs(dt(irw)-dt1)
	avres0=avres0+abs(dt(irw))
	!reduct=((avres0-avres)/avres0)*100.
	!write(*,*)' dt(irw)=',dt(irw),' dt1=',dt1,' reduct=',reduct
end do
avres=avres/nray
avres0=avres0/nray
reduct=((avres0-avres)/avres0)*100.

write(*,*)'_____________________________________________________________'
write(*,*)' avres0=',avres0,' avres=',avres,' red=',reduct
write(*,*)'_____________________________________________________________'

open(1,file='../../DATA/'//ar//'/'//md//'/data/grid.dat')
read(1,*)node
nparam=node
write(*,*)' node=',node,' nparam=',nparam,nvel
allocate(xgrd(node),ygrd(node))
do i=1,node
	read(1,*)xgrd(i),ygrd(i)
end do
close(1)



if(iter.gt.1) open(1,file='../../DATA/'//ar//'/'//md//'/data/dv_result'//it0//'.dat')
open(11,file='../../DATA/'//ar//'/'//md//'/data/dv_result'//it//'.dat')
do i=1,nvel
	dv0=0
	dv1=x(i)
	if(iter.gt.1) read(1,*)dv0
	dv=dv0+dv1


	!write(*,*)' dv0=',dv0,' dv1=',dv1,' dv=',dv

	ygr=ygrd(i)
	xgr=xgrd(i)
	v0=start_velocity(xgr,ygr)

	if(v0+dv.lt.v_min) then
		dv=v_min-v0
		!write(*,*)' dv=',dv
	end if

	!write(*,*)' dv0=',dv0,' x(i)=',x(i),' dv=',dv
	write(11,*)dv	
end do
close(11)
if(iter.gt.1) close(1)

if(K_ztcor.eq.1) then
	open(11,file='../../DATA/'//ar//'/'//md//'/data/ztr_cor'//it//'.dat')
	write(11,*)nzt
	do izt=1,nzt
		dt_corr=x(nvel+izt)*w_ztcor
		write(11,*)dt_corr
		!write(*,*)dt_corr
	end do
	close(11)
end if

stop
end
