character*256 cmd
character*8 ar,md,line
character*1 gr
character*2 it
character*20 scale_line1,scale_line2

character*4 dsaa/'DSAA'/
allocatable dv_map(:,:),v_abs(:,:),v_abs0(:,:),www(:,:)

allocatable xgrd(:),ygrd(:),dvgrd(:)
real yline(600,200),xline(600)
integer non_ln(600),kline(600,200)
real ornt(10)

common/pi/pi,per
common/refmod/nref,href(600),vref(600)
common/relief/nrlf,xrlf(10000),yrlf(10000),sea_lev,v_air,v_sea,v_min
common/syn_start/ k_syn_start

one=1.e0
pi=asin(one)*2.e0
per=pi/180.e0
vsea=1.5
k_syn_start=1


open(1,file='../../model.dat')
read(1,'(a8)')ar
read(1,'(a8)')md
read(1,*)iter
close(1)
write(it,'(i2)')iter


key_preview=0
open(1,file='../../preview_key.txt')
read(1,*,end=771)key_preview
771 close(1)

if(key_preview.ne.0) then
	i=system('mkdir -p ../../PICS/ps/'//ar//'/'//md)
	i=system('mkdir -p ../../PICS/png/'//ar//'/'//md)
	i=system('cp ../../COMMON/gmt/vis_profile.pl ../vis_result/vis_profile.pl')
end if


call read_ISO_ABS(ar,md)
call read_ISO_ANOM(ar,md)

open(1,file='../../DATA/'//ar//'/set_vis.dat')
read(1,*) xmap1,xmap2,dxmap  
read(1,*) ymap1,ymap2,dymap  
read(1,*) dxmax,dymax 
close(1)

write(*,*)' xmap1=',xmap1,' xmap2=',xmap2
write(*,*)' ymap1=',ymap1,' ymap2=',ymap2

nxmap=int_best((xmap2-xmap1)/dxmap)
nymap=int_best((ymap2-ymap1)/dymap)

allocate(dv_map(nxmap,nymap),v_abs(nxmap,nymap),www(nxmap,nymap))
allocate(v_abs0(nxmap,nymap))

write(*,*)' nxmap=',nxmap,' nymap=',nymap


nrlf=0
open(1,file='../../DATA/'//ar//'/inidata/relief.bln',status='old',err=992)
read(1,*,end=92)nrlf,sea_lev,v_air,v_sea,v_min
do irlf=1,nrlf
	read(1,*)xrlf(irlf),yrlf(irlf)
end do
92 close(1)
992 continue


!******************************************************************

open(1,file='../../DATA/'//ar//'/'//md//'/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=533)line
	if(line.eq.'GRID_PAR') goto 534
end do
533 continue
write(*,*)' cannot find GRID_PARAMETERS in MAJOR_PARAM.DAT!!!'
pause
534 continue
read(1,*)xlim1,xlim2,dxpl
read(1,*)ylim1,ylim2,dypl
read(1,*)n_parts
close(1)
nxpl=int_best((xlim2-xlim1)/dxpl)+1
nypl=int_best((ylim2-ylim1)/dypl)+1
xlim2=xlim1+nxpl*dxpl
ylim2=ylim1+nypl*dypl

!******************************************************************


dv_map=0
www=0

!******************************************************************
open(1,file='../../DATA/'//ar//'/'//md//'/data/grid.dat')
open(21,file='../../FIG_files/rays/nodes.dat')
read(1,*)node
allocate(xgrd(node),ygrd(node),dvgrd(node))
do i=1,node
	read(1,*)xgrd(i),ygrd(i)
	write(21,*)xgrd(i),ygrd(i)
end do
close(1)
close(21)

!******************************************************************
open(1,file='../../DATA/'//ar//'/'//md//'/data/dv_result'//it//'.dat')
do i=1,node
	read(1,*)dvgrd(i)		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
end do
close(1)
!******************************************************************



kline=0
nline=1
non_ln(nline)=2
xline(nline)=xlim1
yline(nline,1)=ylim1
yline(nline,2)=ylim2
do ix=1,nxpl
	xln=xlim1+(ix-0.5)*dxpl
	nline=nline+1

	nonln=1
	yline(nline,1)=ylim1

	do inod=1,node
		xxx=xgrd(inod)
		if(abs(xxx-xln).gt.0.001) cycle
		yyy=ygrd(inod)
		nonln=nonln+1
		yline(nline,nonln)=yyy
		kline(nline,nonln)=inod
	end do
	nonln=nonln+1
	yline(nline,nonln)=ylim2
	non_ln(nline)=nonln
	xline(nline)=xln
end do
nline=nline+1
non_ln(nline)=2
xline(nline)=xlim2
yline(nline,1)=ylim1
yline(nline,2)=ylim2

!write(*,*)' nline=',nline



do iymap=1,nymap
	ymid=ymap1+(iymap-1)*dymap
	do ixmap=1,nxmap
		xmid=xmap1+(ixmap-1)*dxmap

!write(*,*)xmid,ymid
!write(*,*)' node=',node
!xmid=155.505386293
!ymid=-5.3806246476
		vmid=start_velocity(xmid,ymid)
!		write(*,*)' vmid=',vmid

		umnn=0
		do i=1,node
			x=xgrd(i)
			y=ygrd(i)

			if(abs(x-xmid).lt.dxmax.and.abs(y-ymid).lt.dymax) then
				umnn=1
				exit
			end if

		end do

		do ix=1,nline-1
			x1=xline(ix)
			x2=xline(ix+1)
			if((xmid-x1)*(xmid-x2).le.0) exit
		end do
		do iy1=1,non_ln(ix)-1
			y11=yline(ix,iy1)
			y12=yline(ix,iy1+1)
			k11=kline(ix,iy1)
			k12=kline(ix,iy1+1)
			if((ymid-y11)*(ymid-y12).le.0) exit
		end do

		do iy2=1,non_ln(ix+1)-1
			y21=yline(ix+1,iy2)
			y22=yline(ix+1,iy2+1)
			k21=kline(ix+1,iy2)
			k22=kline(ix+1,iy2+1)
			if((ymid-y21)*(ymid-y22).le.0) exit
		end do

		dv11=0
		dv12=0
		dv21=0
		dv22=0

		if(k11.ne.0) dv11=dvgrd(k11)
		if(k12.ne.0) dv12=dvgrd(k12)
		if(k21.ne.0) dv21=dvgrd(k21)
		if(k22.ne.0) dv22=dvgrd(k22)

		dv1=dv11+((dv12-dv11)/(y12-y11))*(ymid-y11)
		dv2=dv21+((dv22-dv21)/(y22-y21))*(ymid-y21)
		dvmid=dv1+((dv2-dv1)/(x2-x1))*(xmid-x1)
		dv = 100.*dvmid/vmid
!write(*,*)' dv=',dv,' umnn=',umnn
!pause



		dv_map(ixmap,iymap)=dv_map(ixmap,iymap)+dv*umnn
		www(ixmap,iymap)=www(ixmap,iymap)+umnn
	end do
end do

deallocate(xgrd,ygrd,dvgrd)


vmin=999999
vmax=-999999
vmin0=999999
vmax0=-999999
do iymap=1,nymap
	ymid=ymap1+(iymap-1)*dymap
	do ixmap=1,nxmap

		xmid=xmap1+(ixmap-1)*dxmap

		vmid=start_velocity(xmid,ymid)


		ysurf=relieff(xmid)

		if(ymid.gt.ysurf) www(ixmap,iymap)=0

		dvv=0
		if(www(ixmap,iymap).lt.0.2) then
			dv=-999
			vabs=-999
			vmid=-999
		else
			dv=dv_map(ixmap,iymap)/www(ixmap,iymap)
			dvv=dv
			vabs=vmid * (1 + 0.01*dvv)
		end if

		dv_map(ixmap,iymap)=dv
		v_abs(ixmap,iymap)=vabs
		v_abs0(ixmap,iymap)=vmid 
		!if(ymid.gt.ybot) v_abs0(ixmap,iymap)=vsea
		if(v_abs(ixmap,iymap).gt.vmax)vmax=v_abs(ixmap,iymap)
		if(v_abs(ixmap,iymap).lt.vmin)vmin=v_abs(ixmap,iymap)
		if(v_abs0(ixmap,iymap).gt.vmax0)vmax0=v_abs0(ixmap,iymap)
		if(v_abs0(ixmap,iymap).lt.vmin0)vmin0=v_abs0(ixmap,iymap)
	end do
end do


open(14,file='../../DATA/'//ar//'/'//md//'/data/dv_result.grd')
write(14,'(a4)')dsaa
write(14,*)nxmap,nymap
write(14,*)xmap1,xmap2
write(14,*)ymap1,ymap2
write(14,*)-999,999
do iy=1,nymap
	write(14,*)(dv_map(ix,iy),ix=1,nxmap)
end do
close(14)


open(14,file='../../FIG_files/result/dv_result'//it//'.grd')
write(14,'(a4)')dsaa
write(14,*)nxmap,nymap
write(14,*)xmap1,xmap2
write(14,*)ymap1,ymap2
write(14,*)-999,999
do iy=1,nymap
	write(14,*)(dv_map(ix,iy),ix=1,nxmap)
end do
close(14)


open(14,file='../../FIG_files/result/v_abs'//it//'.grd')
write(14,'(a4)')dsaa
write(14,*)nxmap,nymap
write(14,*)xmap1,xmap2
write(14,*)ymap1,ymap2
write(14,*)vmin,vmax
do iy=1,nymap
	write(14,*)(v_abs(ix,iy),ix=1,nxmap)
end do
close(14)

open(14,file='../../FIG_files/result/v_abs0.grd')
write(14,'(a4)')dsaa
write(14,*)nxmap,nymap
write(14,*)xmap1,xmap2
write(14,*)ymap1,ymap2
write(14,*)vmin0,vmax0
do iy=1,nymap
	write(14,*)(v_abs0(ix,iy),ix=1,nxmap)
end do
close(14)


if(key_preview.eq.0) stop

!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************

write(cmd,787)ar,md,iter
787 format('perl ../vis_result/vis_profile.pl ''',a8,''' ''',a8,''' ''',i2,'''')
write(*,*)cmd

i=system(cmd)
stop
end
