subroutine read_ISO_ABS(ar,md)
character*8 ar,md
common/kod_model/kod_abs, kod_anomaly
common/refmod/nref,href(600),vref(600)
common/syn_start/ k_syn_start

if(k_syn_start.eq.1) then
	open(1,file='../../DATA/'//ar//'/'//md//'/velocity_start.dat')
	write(*,*)' STARTING VELOCITY MODEL'
else if(k_syn_start.eq.2) then
	open(1,file='../../DATA/'//ar//'/'//md//'/velocity_syn.dat')
	write(*,*)' SYNTHETIC VELOCITY MODEL'
else
	write(*,*)' k_syn_start is not defined:',k_syn_start
	pause
end if


read(1,*) kod_abs  
close(1)
write(*,*)' kod_abs=',kod_abs

if(kod_abs.eq.1)then
	write(*,*)' 1D absolute velocity:'

	if(k_syn_start.eq.1) then
		open(1,file='../../DATA/'//ar//'/'//md//'/velocity_start.dat')
	else if(k_syn_start.eq.2) then
		open(1,file='../../DATA/'//ar//'/'//md//'/velocity_syn.dat')
	else
		write(*,*)' k_syn_start is not defined:',k_syn_start
		pause
	end if

	open(11,file='../../DATA/'//ar//'/'//md//'/data/vref_syn.bln')
	read(1,*)
	read(1,*)
	read(1,*)nref
	write(11,*)nref
	do i=1,nref
		read(1,*)href(i),vref(i)
		write(11,*)vref(i),-href(i)
	end do
	close(1)
	close(11)
else if(kod_abs.eq.2)then
	write(*,*)' Absolute velocity model by free patterns: '
	call read_FREE_abs(ar,md)
else if(kod_abs.eq.3)then
	write(*,*)' 2D velocity model in grid: '
	call read_2D_vel(ar,md)
else if(kod_abs.eq.4)then
	write(*,*)' 2D velocity model by interfaces: '
	call read_abs_INTERF(ar,md)
else if(kod_abs.eq.5)then
	write(*,*)' Gradient between two lines: '
	call read_ver_grad(ar,md)
else if(kod_abs.eq.6)then
	write(*,*)' Gradient between polylines: '
	call read_grad_lines(ar,md)
end if



return
end