subroutine circle_line(xxx1,yyy1,xxx2,yyy2, tray)
common/ray_xyv/nodes,xray(1000),yray(1000),vray(1000),sray(1000)
common/param_reg_bend/step,segm_min,bendreg_min,bendreg_max
common/pi/pi,per
common/visual/k_prn_circle,k_prn_bend

real xbest(1000),ybest(1000),vbest(1000),sbest(1000)



!write(*,*)' xxx1=',xxx1,' yyy1=',yyy1
!write(*,*)' xxx2=',xxx2,' yyy2=',yyy2



call streight_line(xxx1,yyy1,xxx2,yyy2, tray)

if(k_prn_circle.eq.1) open(31,file='../../FIG_files/rays/all_circles.bln')


tbest=tray
nbest=nodes
xbest=xray
ybest=yray
sbest=sray
vbest=vray




dist=sqrt((xxx2-xxx1)**2 + (yyy2-yyy1)**2)
dbend_cur=bendreg_max
bend=dbend_cur
rad0=dist/2
isign=1

111 continue
rad=rad0+bend

sinal=(yyy2-yyy1)/dist
cosal=(xxx2-xxx1)/dist

x1=xxx1*cosal+yyy1*sinal
y1=-xxx1*sinal+yyy1*cosal

x2=xxx2*cosal+yyy2*sinal
y2=-xxx2*sinal+yyy2*cosal

x0=x1+(x2-x1)/2.
y0=y1+sqrt(rad*rad - (x0-x1)*(x0-x1))

rad1=sqrt((x1-x0)**2+(y1-y0)**2)
rad2=sqrt((x2-x0)**2+(y2-y0)**2)

xxx0=x0*cosal-y0*sinal
yyy0=x0*sinal+y0*cosal
fi1=-acos((xxx1-xxx0)/rad)/per

xcur1=xxx0+rad*cos(fi1*per)
ycur1=yyy0+rad*sin(fi1*per)

fi2=-acos((xxx2-xxx0)/rad)/per

xcur2=xxx0+rad*cos(fi2*per)
ycur2=yyy0+rad*sin(fi2*per)

dang0=(step/rad)/per

nang=abs(fi2-fi1)/dang0

dang=(fi2-fi1)/nang

nodes=nang+1

sss=0
do iang=1,nodes
	ang=fi1+(iang-1)*dang
	sray(iang)=(iang-1)*dang*per*rad
	x=xxx0+rad*cos(ang*per)
	y=yyy0+rad*sin(ang*per)
	xray(iang)=x
	yray(iang)=y
	vray(iang)=velocity(x,y)
end do

tray=0
do inod=2,nodes
	ds=sray(inod)-sray(inod-1)
	vm=(vray(inod)+vray(inod-1))/2.
	tray=tray+ds/vm
end do
!write(*,*)' bend=',bend,' tray=',tray,' tbest=',tbest

if(k_prn_circle.eq.1) then
	write(31,*)nodes
	do iang=1,nodes
		x=xray(iang)
		y=yray(iang)
		write(31,*)x,y
	end do
end if


if(tray.lt.tbest) then
	tbest=tray
	nbest=nodes
	xbest=xray
	ybest=yray
	sbest=sray
	vbest=vray
	bend_best=bend
	!write(*,*)' SUCCESS: bend=',bend,' tbest=',tbest
	bend=bend+dbend_cur
	goto 111
else
	bend=bend_best
	if(isign.eq.1) then
		dbend_cur=dbend_cur/2.
	end if
	!write(*,*)' dbend=',isign*dbend_cur,' bend=',bend
	bend=bend+isign*dbend_cur
	isign=-isign
	if(dbend_cur.gt.bendreg_min) goto 111

end if

tray=tbest
nodes=nbest
xray=xbest
yray=ybest
sray=sbest
vray=vbest

if(k_prn_circle.eq.1) then
	open(51,file='../../FIG_files/rays/circle.dat')
	do iang=1,nodes
		x=xray(iang)
		y=yray(iang)
		write(51,*)x,y
	end do
	close(51)
	close(31)
end if


return
end