subroutine ray_refr_segm(xzt,yzt,xbnce1,ybnce1,xbnce2,ybnce2,xst,yst,isrf,time)

real xsrf1(100),ysrf1(100)


common/ray_lin_srf/nseg,nod_refl,xseg(100),yseg(100),sseg(100),isrfseg(100)
common/interf/nsurf,nodsrf(10),xsurf(100,10),ysurf(100,10),ksurf(100,10)
common/refr_param/down
common/lin_bend_param/segm_lin_min,bend_lin_max,bend_lin_min



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Intersection with other interfaces

x1=xzt
y1=yzt
x2=xbnce1
y2=ybnce1

k_vert=0
if(abs(x2-x1).lt.000.1) k_vert=1

if(k_vert.eq.0) then
	A1=(y2-y1)/(x2-x1)
	B1=(x2*y1-x1*y2)/(x2-x1)
end if
!write(*,*)' k_vert=',k_vert

nseg=1
xseg(nseg)=xzt
yseg(nseg)=yzt
isrfseg(nseg)=0

if(isrf.ne.1) then

	do inter=1,isrf-1
		xpr=x1
		if(k_vert.eq.0) then
			do inod=2,nodsrf(inter)
				x3=xsurf(inod-1,inter)
				x4=xsurf(inod,inter)
				y3=ysurf(inod-1,inter)
				y4=ysurf(inod,inter)


				A2=(y4-y3)/(x4-x3)
				B2=(x4*y3-x3*y4)/(x4-x3)

				if(abs(A1-A2).lt.0.00001) then
					write(*,*)' the lines are parallel !!!'
					pause
				end if
				xpr=(B2-B1) / (A1-A2)
				ypr=(A1*B2 - A2*B1) / (A1-A2)
				if((xpr-x3)*(xpr-x4).le.0) goto 51

			end do
			!write(*,*)' cannot find intersection'
			goto 151
			return
51			continue
		end if
		call yyy_interface(xpr,inter, ypr,kod)
		!write(*,*)inter,' x=',xpr,' y=',ypr,kod
		if(kod.ne.0) then
			nseg=nseg+1
			xseg(nseg)=xpr
			yseg(nseg)=ypr
			isrfseg(nseg)=inter
		end if
151		continue
	end do
end if


nseg=nseg+1
xseg(nseg)=xbnce1
yseg(nseg)=ybnce1-down
isrfseg(nseg)=isrf
nod_refl=nseg
xlast=xbnce1

do i=1,nodsrf(isrf)
	xsrf1(i)=xsurf(i,isrf)
	ysrf1(i)=ysurf(i,isrf)
end do
nsrf1=nodsrf(isrf)

256 continue
dxmin=999999999
imin=0
do icur=1,nsrf1
	xcur=xsrf1(icur)
	if(xcur.le.xlast) cycle
	if(xcur.gt.xbnce2) cycle
	dx=xcur-xlast
	!write(*,*)' xcur=',xcur,' xlast=',xlast,' dx=',dx
	if(dx.le.0.001) cycle
	if(dx.lt.dxmin) then
		dxmin=dx
		imin=icur
	end if
end do

if(imin.ne.0) then
	nseg=nseg+1
	xseg(nseg)=xsrf1(imin)
	yseg(nseg)=ysrf1(imin)-down
	isrfseg(nseg)=isrf
	xlast=xsrf1(imin)
	goto 256
end if


nseg=nseg+1
xseg(nseg)=xbnce2
yseg(nseg)=ybnce2-down
isrfseg(nseg)=isrf


x1=xst
y1=yst
x2=xbnce2
y2=ybnce2


k_vert=0
if(abs(x2-x1).lt.000.1) k_vert=1

if(k_vert.eq.0) then
	A1=(y2-y1)/(x2-x1)
	B1=(x2*y1-x1*y2)/(x2-x1)
end if


if(isrf.ne.1) then
	do inter=isrf-1,1,-1
		xpr=x1
		if(k_vert.eq.0) then
			!write(*,*)' inter=',inter,' a1=',a1,' b1=',b1
			do inod=2,nodsrf(inter)
				x3=xsurf(inod-1,inter)
				x4=xsurf(inod,inter)
				y3=ysurf(inod-1,inter)
				y4=ysurf(inod,inter)

				A2=(y4-y3)/(x4-x3)
				B2=(x4*y3-x3*y4)/(x4-x3)

				if(abs(A1-A2).lt.0.00001) then
					write(*,*)' the lines are parallel !!!'
					pause
				end if
				xpr=(B2-B1) / (A1-A2)
				ypr=(A1*B2 - A2*B1) / (A1-A2)
				if((xpr-x3)*(xpr-x4).le.0) goto 52

			end do
			!write(*,*)' cannot find intersection'
			goto 152
52			continue
		end if
		call yyy_interface(xpr,inter, ypr,kod)
		!write(*,*)inter,' x=',xpr,' y=',ypr,kod
		if(kod.ne.0) then
			nseg=nseg+1
			xseg(nseg)=xpr
			yseg(nseg)=ypr
			isrfseg(nseg)=inter
		end if
152		continue
	end do
end if
nseg=nseg+1
xseg(nseg)=xst
yseg(nseg)=yst
isrfseg(nseg)=0


sseg(1)=0
do iseg=2,nseg
	!write(*,*)xbend(i),ybend(i)
	x1=xseg(iseg-1)
	x2=xseg(iseg)
	y1=yseg(iseg-1)
	y2=yseg(iseg)
	ds=sqrt((x2-x1)**2+(y2-y1)**2)
	sseg(iseg)=sseg(iseg-1)+ds
end do


stot=sseg(nseg)

!write(*,*)' nseg=',nseg
!do i=1,nseg
	!write(*,*)xseg(i),yseg(i),sseg(i),isrfseg(i)
!end do

call renumb_lin(isrf)

!write(*,*)' nseg=',nseg
!do i=1,nseg
	!write(*,*)xseg(i),yseg(i),sseg(i),isrfseg(i)
!end do

time = time_lin_srf()


return
end