function velocity(x,y)
common/relief/nrlf,xrlf(10000),yrlf(10000),sea_lev,v_air,v_sea,v_min
common/kod_model/kod_abs, kod_anomaly

rlf = relieff(x)
sea = sea_lev
!write(*,*),'x=',x,' y=',y,' rlf=',rlf,' sea=',sea,' v_min=',v_min



if(y.gt.sea.and.y.gt.rlf) then
	velocity=v_air
	return
end if

if(y.gt.rlf.and.y.le.sea) then
	velocity=v_sea
	return
end if


if(kod_abs.eq.1) then
	vabs=vrefmod(y)
else if(kod_abs.eq.2) then
	call abs_FREE_iso(x,y,vabs)
else if(kod_abs.eq.4) then
	call abs_FREE_iso(x,y,vabs)
else if(kod_abs.eq.3) then
	call SYN_VEL_2D(x,y,vabs)
else if(kod_abs.eq.5) then
	call VER_GRAD(x,y,vabs)
else if(kod_abs.eq.6) then
	call grad_lines(x,y,vabs)
else
	write(*,*)' Absolute velocity model is not defined'
	pause
end if

!if(y.gt.10) vabs=300

!write(*,*)' kod_abs=',kod_abs,' vabs=',vabs
dv = 0

if(kod_anomaly.ne.0) then
	call SYN_ISO_ANOM(x,y,dv)
end if


v0 = vabs * (1. + dv/100.)

!write(*,*)' v0=',v0,' x=',x,' y=',y

dv_prev=dv_mod_2d(x,y)
!write(*,*)' dv_prev=',dv_prev

velocity = v0 + dv_prev

!write(*,*)'velocity=',velocity
if(velocity.lt.v_min) velocity=v_min


return
end
